/* 
 * This message is auto generated by ROS#. Please DO NOT modify.
 * Note:
 * - Comments from the original code will be written in their own line 
 * - Variable sized arrays will be initialized to array of size 0 
 * Please report any issues at 
 * <https://github.com/siemens/ros-sharp> 
 */

using Newtonsoft.Json;

using RosSharp.RosBridgeClient.MessageTypes.Std;
using RosSharp.RosBridgeClient.MessageTypes.Geometry;

namespace RosSharp.RosBridgeClient.MessageTypes.CocktailpartyToUnity
{
    public class PersonTrajectoryEntry : Message
    {
        [JsonIgnore]
        public const string RosMessageName = "cocktailparty_to_unity/PersonTrajectoryEntry";

        //  from: https://github.com/spencer-project/spencer_people_tracking/blob/master/messages/spencer_tracking_msgs/msg/PersonTrajectoryEntry.msg
        //  Message defining an entry of a person trajectory.
        // 
        public Time stamp;
        //  age of the track
        public bool is_occluded;
        //  if the track is currently not matched by a detection
        public ulong detection_id;
        //  id of the corresponding detection in the current cycle (undefined if occluded)
        //  The following fields are extracted from the Kalman state x and its covariance C
        public PoseWithCovariance pose;
        //  pose of the track (z value and orientation might not be set, check if corresponding variance on diagonal is > 99999)
        public TwistWithCovariance twist;
        //  velocity of the track (z value and rotational velocities might not be set, check if corresponding variance on diagonal is > 99999)

        public PersonTrajectoryEntry()
        {
            this.stamp = new Time();
            this.is_occluded = false;
            this.detection_id = 0;
            this.pose = new PoseWithCovariance();
            this.twist = new TwistWithCovariance();
        }

        public PersonTrajectoryEntry(Time stamp, bool is_occluded, ulong detection_id, PoseWithCovariance pose, TwistWithCovariance twist)
        {
            this.stamp = stamp;
            this.is_occluded = is_occluded;
            this.detection_id = detection_id;
            this.pose = pose;
            this.twist = twist;
        }
    }
}
